from Numeric import *

class ColorMatrixFilter:
	rwgt = 0.3086
	gwgt = 0.6094
	bwgt = 0.0820
	
	def __init__(self, matrix=array(([1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]))):
		self.matrix = matrix
	
	def reset(self):
		self.matrix = array(([1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]))
	
	def setBrightness(self, (r, g, b)):
		self.matrix[4,0] = r
		self.matrix[4,1] = g
		self.matrix[4,2] = b
		
	def getLuminanceMatrix(self):
		r = self.rwgt
		g = self.gwgt
		b = self.bwgt
		return array(([r,r,r,0],[g,g,g,0],[b,b,b,0],[0,0,0,1]))
	
	def getSaturationMatrix(self, s=1.0):
		a = (1.0-s)*self.rwgt + s;
		b = (1.0-s)*self.rwgt;
		c = (1.0-s)*self.rwgt;
		d = (1.0-s)*self.gwgt;
		e = (1.0-s)*self.gwgt + s;
		f = (1.0-s)*self.gwgt;
		g = (1.0-s)*self.bwgt;
		h = (1.0-s)*self.bwgt;
		i = (1.0-s)*self.bwgt + s;
		return array(([a,b,c,0],[d,e,f,0],[g,h,i,0],[0,0,0,1]))
	
	def applyFilter(self, imagematrix):
		shape = imagematrix.shape[:]
		m = resize(imagematrix, (shape[0]*shape[1], shape[2]))
		multiplied_m = array(map(lambda x: matrixmultiply(self.matrix, concatenate([x, [1]]) )[0:3], m))
		print self.matrix
		print imagematrix[0::]
		print multiplied_m[0::]
		return resize(multiplied_m, shape)